autotest.sh 14 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334335336337338339340341342343344345346347348349350351352353354355356357358359360361362363364365366367368369370371372373374375376377378379380381382383384385386387388389390391392393394395396397398399400401402403404405406407408409410411412413414415416417418419420421422423424425426427428429430431432433434435436437438439440441442443444445
  1. #!/usr/bin/env bash
  2. #
  3. # ownCloud
  4. #
  5. # @author Vincent Petry
  6. # @author Morris Jobke
  7. # @author Robin McCorkell
  8. # @author Thomas Müller
  9. # @author Andreas Fischer
  10. # @author Joas Schilling
  11. # @author Lukas Reschke
  12. # @author Jörn Friedrich Dreyer
  13. # @copyright 2012-2015 Thomas Müller thomas.mueller@tmit.eu
  14. #
  15. #$EXECUTOR_NUMBER is set by Jenkins and allows us to run autotest in parallel
  16. DATABASENAME=oc_autotest$EXECUTOR_NUMBER
  17. DATABASEUSER=oc_autotest$EXECUTOR_NUMBER
  18. DATABASEHOST=localhost
  19. ADMINLOGIN=admin$EXECUTOR_NUMBER
  20. BASEDIR=$PWD
  21. PRIMARY_STORAGE_CONFIGS="local swift"
  22. DBCONFIGS="sqlite mysql mariadb pgsql oci mysqlmb4"
  23. # $PHP_EXE is run through 'which' and as such e.g. 'php' or 'hhvm' is usually
  24. # sufficient. Due to the behaviour of 'which', $PHP_EXE may also be a path
  25. # (absolute or not) to an executable, e.g. ./code/projects/php-src/sapi/cli/php.
  26. if [ -z "$PHP_EXE" ]; then
  27. PHP_EXE=php
  28. fi
  29. PHP=$(which "$PHP_EXE")
  30. PHPUNIT=$(which phpunit)
  31. set -e
  32. _XDEBUG_CONFIG=$XDEBUG_CONFIG
  33. unset XDEBUG_CONFIG
  34. function print_syntax {
  35. echo -e "Syntax: ./autotest.sh [dbconfigname] [testfile]\n" >&2
  36. echo -e "\t\"dbconfigname\" can be one of: $DBCONFIGS" >&2
  37. echo -e "\t\"testfile\" is the name of a test file, for example lib/template.php" >&2
  38. echo -e "\nExample: ./autotest.sh sqlite lib/template.php" >&2
  39. echo "will run the test suite from \"tests/lib/template.php\"" >&2
  40. echo -e "\nIf no arguments are specified, all tests will be run with all database configs" >&2
  41. }
  42. if [ -x "$PHP" ]; then
  43. echo "Using PHP executable $PHP"
  44. else
  45. echo "Could not find PHP executable $PHP_EXE" >&2
  46. exit 3
  47. fi
  48. if ! [ -x "$PHPUNIT" ]; then
  49. echo "phpunit executable not found, please install phpunit version >= 4.8" >&2
  50. exit 3
  51. fi
  52. # PHPUnit might also be installed via a facade binary script
  53. if [[ "$PHPUNIT" =~ \.phar$ ]]; then
  54. PHPUNIT=( "$PHP" "$PHPUNIT" )
  55. else
  56. PHPUNIT=( "$PHPUNIT" )
  57. fi
  58. PHPUNIT_VERSION=$($PHPUNIT --version | cut -d" " -f2)
  59. PHPUNIT_MAJOR_VERSION=$(echo "$PHPUNIT_VERSION" | cut -d"." -f1)
  60. PHPUNIT_MINOR_VERSION=$(echo "$PHPUNIT_VERSION" | cut -d"." -f2)
  61. if ! [ "$PHPUNIT_MAJOR_VERSION" -gt 4 -o \( "$PHPUNIT_MAJOR_VERSION" -eq 4 -a "$PHPUNIT_MINOR_VERSION" -ge 8 \) ]; then
  62. echo "phpunit version >= 4.8 required. Version found: $PHPUNIT_VERSION" >&2
  63. exit 4
  64. fi
  65. if ! [ \( -w config -a ! -f config/config.php \) -o \( -f config/config.php -a -w config/config.php \) ]; then
  66. echo "Please enable write permissions on config and config/config.php" >&2
  67. exit 1
  68. fi
  69. if [ "$1" ]; then
  70. FOUND=0
  71. for DBCONFIG in $DBCONFIGS; do
  72. if [ "$1" = "$DBCONFIG" ]; then
  73. FOUND=1
  74. break
  75. fi
  76. done
  77. if [ $FOUND = 0 ]; then
  78. echo -e "Unknown database config name \"$1\"\n" >&2
  79. print_syntax
  80. exit 2
  81. fi
  82. fi
  83. if [ "$PRIMARY_STORAGE_CONFIG" ]; then
  84. FOUND=0
  85. for PSC in $PRIMARY_STORAGE_CONFIGS; do
  86. if [ "$PRIMARY_STORAGE_CONFIG" = "$PSC" ]; then
  87. FOUND=1
  88. break
  89. fi
  90. done
  91. if [ $FOUND = 0 ]; then
  92. echo -e "Unknown primary storage config name \"$PRIMARY_STORAGE_CONFIG\"\n" >&2
  93. print_syntax
  94. exit 2
  95. fi
  96. else
  97. PRIMARY_STORAGE_CONFIG="local"
  98. fi
  99. # check for the presence of @since in all OCP methods
  100. $PHP build/OCPSinceChecker.php
  101. # Back up existing (dev) config if one exists and backup not already there
  102. if [ -f config/config.php ] && [ ! -f config/config-autotest-backup.php ]; then
  103. mv config/config.php config/config-autotest-backup.php
  104. fi
  105. function cleanup_config {
  106. if [ ! -z "$DOCKER_CONTAINER_ID" ]; then
  107. echo "Kill the docker $DOCKER_CONTAINER_ID"
  108. docker stop "$DOCKER_CONTAINER_ID"
  109. docker rm -f "$DOCKER_CONTAINER_ID"
  110. fi
  111. cd "$BASEDIR"
  112. if [ "$PRIMARY_STORAGE_CONFIG" == "swift" ] ; then
  113. echo "Kill the swift docker"
  114. tests/objectstore/stop-swift-ceph.sh
  115. fi
  116. # Restore existing config
  117. if [ -f config/config-autotest-backup.php ]; then
  118. mv config/config-autotest-backup.php config/config.php
  119. fi
  120. # Remove autotest config
  121. if [ -f config/autoconfig.php ]; then
  122. rm config/autoconfig.php
  123. fi
  124. # Remove autotest swift storage config
  125. if [ -f config/autotest-storage-swift.config.php ]; then
  126. rm config/autotest-storage-swift.config.php
  127. fi
  128. # Remove autotest redis config
  129. if [ -f config/redis.config.php ]; then
  130. rm config/redis.config.php
  131. fi
  132. # Remove mysqlmb4.config.php
  133. rm -f config/mysqlmb4.config.php
  134. }
  135. # restore config on exit
  136. trap cleanup_config EXIT
  137. # use tmpfs for datadir - should speedup unit test execution
  138. if [ -d /dev/shm ]; then
  139. DATADIR=/dev/shm/data-autotest$EXECUTOR_NUMBER
  140. else
  141. DATADIR=$BASEDIR/data-autotest
  142. fi
  143. echo "Using database $DATABASENAME"
  144. function execute_tests {
  145. DB=$1
  146. echo "Setup environment for $DB testing on $PRIMARY_STORAGE_CONFIG storage ..."
  147. # back to root folder
  148. cd "$BASEDIR"
  149. # revert changes to tests/data
  150. git checkout tests/data
  151. # reset data directory
  152. rm -rf "$DATADIR"
  153. mkdir "$DATADIR"
  154. if [ "$PRIMARY_STORAGE_CONFIG" == "swift" ] ; then
  155. tests/objectstore/start-swift-ceph.sh
  156. cp tests/objectstore/swift.config.php config/autotest-storage-swift.config.php
  157. fi
  158. cp tests/preseed-config.php config/config.php
  159. if [ "$ENABLE_REDIS" == "true" ] ; then
  160. cp tests/redis.config.php config/redis.config.php
  161. elif [ "$ENABLE_REDIS_CLUSTER" == "true" ] ; then
  162. cp tests/redis-cluster.config.php config/redis.config.php
  163. fi
  164. _DB=$DB
  165. # drop database
  166. if [ "$DB" == "mysql" ] ; then
  167. if [ ! -z "$USEDOCKER" ] ; then
  168. echo "Fire up the mysql docker"
  169. DOCKER_CONTAINER_ID=$(docker run \
  170. -v $BASEDIR/tests/docker/mariadb:/etc/mysql/conf.d \
  171. -e MYSQL_ROOT_PASSWORD=owncloud \
  172. -e MYSQL_USER="$DATABASEUSER" \
  173. -e MYSQL_PASSWORD=owncloud \
  174. -e MYSQL_DATABASE="$DATABASENAME" \
  175. -d mysql)
  176. DATABASEHOST=$(docker inspect --format="{{.NetworkSettings.IPAddress}}" "$DOCKER_CONTAINER_ID")
  177. else
  178. if [ -z "$DRONE" ] ; then # no need to drop the DB when we are on CI
  179. if [ "mysql" != "$(mysql --version | grep -o mysql)" ] ; then
  180. echo "Your mysql binary is not provided by mysql"
  181. echo "To use the docker container set the USEDOCKER environment variable"
  182. exit -1
  183. fi
  184. mysql -u "$DATABASEUSER" -powncloud -e "DROP DATABASE IF EXISTS $DATABASENAME" -h $DATABASEHOST || true
  185. else
  186. DATABASEHOST=127.0.0.1
  187. fi
  188. fi
  189. echo "Waiting for MySQL initialisation ..."
  190. if ! apps/files_external/tests/env/wait-for-connection $DATABASEHOST 3306 600; then
  191. echo "[ERROR] Waited 600 seconds, no response" >&2
  192. exit 1
  193. fi
  194. fi
  195. if [ "$DB" == "mysqlmb4" ] ; then
  196. if [ ! -z "$USEDOCKER" ] ; then
  197. echo "Fire up the mysql docker"
  198. DOCKER_CONTAINER_ID=$(docker run \
  199. -v $BASEDIR/tests/docker/mysqlmb4:/etc/mysql/conf.d \
  200. -e MYSQL_ROOT_PASSWORD=owncloud \
  201. -e MYSQL_USER="$DATABASEUSER" \
  202. -e MYSQL_PASSWORD=owncloud \
  203. -e MYSQL_DATABASE="$DATABASENAME" \
  204. -d mysql:5.7
  205. --innodb_large_prefix=true
  206. --innodb_file_format=barracuda
  207. --innodb_file_per_table=true)
  208. DATABASEHOST=$(docker inspect --format="{{.NetworkSettings.IPAddress}}" "$DOCKER_CONTAINER_ID")
  209. else
  210. if [ -z "$DRONE" ] ; then # no need to drop the DB when we are on CI
  211. if [ "mysql" != "$(mysql --version | grep -o mysql)" ] ; then
  212. echo "Your mysql binary is not provided by mysql"
  213. echo "To use the docker container set the USEDOCKER environment variable"
  214. exit -1
  215. fi
  216. mysql -u "$DATABASEUSER" -powncloud -e "DROP DATABASE IF EXISTS $DATABASENAME" -h $DATABASEHOST || true
  217. else
  218. DATABASEHOST=127.0.0.1
  219. fi
  220. fi
  221. echo "Waiting for MySQL(utf8mb4) initialisation ..."
  222. if ! apps/files_external/tests/env/wait-for-connection $DATABASEHOST 3306 600; then
  223. echo "[ERROR] Waited 600 seconds, no response" >&2
  224. exit 1
  225. fi
  226. sleep 1
  227. echo "MySQL(utf8mb4) is up."
  228. _DB="mysql"
  229. cp tests/docker/mysqlmb4.config.php config
  230. fi
  231. if [ "$DB" == "mariadb" ] ; then
  232. if [ ! -z "$USEDOCKER" ] ; then
  233. echo "Fire up the mariadb docker"
  234. DOCKER_CONTAINER_ID=$(docker run \
  235. -v $BASEDIR/tests/docker/mariadb:/etc/mysql/conf.d \
  236. -e MYSQL_ROOT_PASSWORD=owncloud \
  237. -e MYSQL_USER="$DATABASEUSER" \
  238. -e MYSQL_PASSWORD=owncloud \
  239. -e MYSQL_DATABASE="$DATABASENAME" \
  240. -d mariadb)
  241. DATABASEHOST=$(docker inspect --format="{{.NetworkSettings.IPAddress}}" "$DOCKER_CONTAINER_ID")
  242. echo "Waiting for MariaDB initialisation ..."
  243. if ! apps/files_external/tests/env/wait-for-connection $DATABASEHOST 3306 600; then
  244. echo "[ERROR] Waited 600 seconds, no response" >&2
  245. exit 1
  246. fi
  247. echo "MariaDB is up."
  248. else
  249. if [ "MariaDB" != "$(mysql --version | grep -o MariaDB)" ] ; then
  250. echo "Your mysql binary is not provided by MariaDB"
  251. echo "To use the docker container set the USEDOCKER environment variable"
  252. exit -1
  253. fi
  254. mysql -u "$DATABASEUSER" -powncloud -e "DROP DATABASE IF EXISTS $DATABASENAME" -h $DATABASEHOST || true
  255. fi
  256. #Reset _DB to mysql since that is what we use internally
  257. _DB="mysql"
  258. fi
  259. if [ "$DB" == "pgsql" ] ; then
  260. if [ ! -z "$USEDOCKER" ] ; then
  261. echo "Fire up the postgres docker"
  262. DOCKER_CONTAINER_ID=$(docker run -e POSTGRES_USER="$DATABASEUSER" -e POSTGRES_PASSWORD=owncloud -d postgres)
  263. DATABASEHOST=$(docker inspect --format="{{.NetworkSettings.IPAddress}}" "$DOCKER_CONTAINER_ID")
  264. echo "Waiting for Postgres initialisation ..."
  265. # grep exits on the first match and then the script continues
  266. docker logs -f "$DOCKER_CONTAINER_ID" 2>&1 | grep -q "database system is ready to accept connections"
  267. echo "Postgres is up."
  268. else
  269. echo "Waiting for Postgres to be available ..."
  270. if ! apps/files_external/tests/env/wait-for-connection $DATABASEHOST 5432 60; then
  271. echo "[ERROR] Waited 60 seconds, no response" >&2
  272. exit 1
  273. fi
  274. echo "Give it 10 additional seconds ..."
  275. sleep 10
  276. if [ -z "$DRONE" ] ; then # no need to drop the DB when we are on CI
  277. dropdb -U "$DATABASEUSER" "$DATABASENAME" || true
  278. fi
  279. fi
  280. fi
  281. if [ "$DB" == "oci" ] ; then
  282. echo "Fire up the oracle docker"
  283. DOCKER_CONTAINER_ID=$(docker run -d deepdiver/docker-oracle-xe-11g)
  284. DATABASEHOST=$(docker inspect --format="{{.NetworkSettings.IPAddress}}" "$DOCKER_CONTAINER_ID")
  285. echo "Waiting for Oracle initialization ... "
  286. # Try to connect to the OCI host via sqlplus to ensure that the connection is already running
  287. for i in {1..48}
  288. do
  289. if sqlplus "autotest/owncloud@(DESCRIPTION=(ADDRESS=(PROTOCOL=TCP)(Host=$DATABASEHOST)(Port=1521))(CONNECT_DATA=(SID=XE)))" < /dev/null | grep 'Connected to'; then
  290. break;
  291. fi
  292. sleep 5
  293. done
  294. DATABASEUSER=autotest
  295. DATABASENAME='XE'
  296. fi
  297. # trigger installation
  298. echo "Installing ...."
  299. "$PHP" ./occ maintenance:install -vvv --database="$_DB" --database-name="$DATABASENAME" --database-host="$DATABASEHOST" --database-user="$DATABASEUSER" --database-pass=owncloud --database-table-prefix=oc_ --admin-user="$ADMINLOGIN" --admin-pass=admin --data-dir="$DATADIR"
  300. #test execution
  301. echo "Testing with $DB ..."
  302. cd tests
  303. rm -rf "coverage-html-$DB"
  304. mkdir "coverage-html-$DB"
  305. "$PHP" -f enable_all.php | grep -i -C9999 error && echo "Error during setup" && exit 101
  306. if [[ "$_XDEBUG_CONFIG" ]]; then
  307. export XDEBUG_CONFIG=$_XDEBUG_CONFIG
  308. fi
  309. GROUP=''
  310. if [ "$TEST_SELECTION" == "QUICKDB" ]; then
  311. GROUP='--group DB --exclude-group=SLOWDB'
  312. fi
  313. if [ "$TEST_SELECTION" == "DB" ]; then
  314. GROUP='--group DB,SLOWDB'
  315. fi
  316. if [ "$TEST_SELECTION" == "NODB" ]; then
  317. GROUP='--exclude-group DB,SLOWDB'
  318. fi
  319. if [ "$TEST_SELECTION" == "PRIMARY-s3" ]; then
  320. GROUP='--group PRIMARY-s3'
  321. fi
  322. COVER=''
  323. if [ -z "$NOCOVERAGE" ]; then
  324. COVER="--coverage-clover autotest-clover-$DB.xml --coverage-html coverage-html-$DB"
  325. else
  326. echo "No coverage"
  327. fi
  328. if [ -d "$2" ]; then
  329. for f in $(find "$2" -name '*Test.php'); do
  330. echo "${PHPUNIT[@]}" --configuration phpunit-autotest.xml $GROUP $COVER --log-junit "autotest-results-$DB.xml" "$2" / "$f" "$3"
  331. "${PHPUNIT[@]}" --configuration phpunit-autotest.xml $GROUP $COVER --log-junit "autotest-results-$DB.xml" "$f" "$3"
  332. RESULT=$?
  333. done;
  334. else
  335. echo "${PHPUNIT[@]}" --configuration phpunit-autotest.xml $GROUP $COVER --log-junit "autotest-results-$DB.xml" "$2" "$3"
  336. "${PHPUNIT[@]}" --configuration phpunit-autotest.xml $GROUP $COVER --log-junit "autotest-results-$DB.xml" "$2" "$3"
  337. RESULT=$?
  338. fi
  339. if [ "$PRIMARY_STORAGE_CONFIG" == "swift" ] ; then
  340. cd ..
  341. echo "Kill the swift docker"
  342. tests/objectstore/stop-swift-ceph.sh
  343. fi
  344. if [ ! -z "$DOCKER_CONTAINER_ID" ] ; then
  345. echo "Kill the docker $DOCKER_CONTAINER_ID"
  346. docker stop $DOCKER_CONTAINER_ID
  347. docker rm -f $DOCKER_CONTAINER_ID
  348. unset DOCKER_CONTAINER_ID
  349. fi
  350. }
  351. #
  352. # start test execution
  353. #
  354. if [ -z "$1" ]
  355. then
  356. # run all known database configs
  357. for DBCONFIG in $DBCONFIGS; do
  358. execute_tests "$DBCONFIG"
  359. done
  360. else
  361. FILENAME="$2"
  362. if [ ! -z "$2" ] && [ ! -f "tests/$FILENAME" ] && [ "${FILENAME:0:2}" != "--" ]; then
  363. FILENAME="../$FILENAME"
  364. fi
  365. execute_tests "$1" "$FILENAME" "$3"
  366. fi
  367. #
  368. # NOTES on mysql:
  369. # - CREATE DATABASE oc_autotest;
  370. # - CREATE USER 'oc_autotest'@'localhost' IDENTIFIED BY 'owncloud';
  371. # - grant all on oc_autotest.* to 'oc_autotest'@'localhost';
  372. #
  373. # - for parallel executor support with EXECUTOR_NUMBER=0:
  374. # - CREATE DATABASE oc_autotest0;
  375. # - CREATE USER 'oc_autotest0'@'localhost' IDENTIFIED BY 'owncloud';
  376. # - grant all on oc_autotest0.* to 'oc_autotest0'@'localhost';
  377. #
  378. # NOTES on pgsql:
  379. # - su - postgres
  380. # - createuser -P oc_autotest (enter password and enable superuser)
  381. # - to enable dropdb I decided to add following line to pg_hba.conf (this is not the safest way but I don't care for the testing machine):
  382. # local all all trust
  383. #
  384. # - for parallel executor support with EXECUTOR_NUMBER=0:
  385. # - createuser -P oc_autotest0 (enter password and enable superuser)
  386. #
  387. # NOTES on oci:
  388. # - it's a pure nightmare to install Oracle on a Linux-System
  389. # - DON'T TRY THIS AT HOME!
  390. # - if you really need it: we feel sorry for you
  391. #